searchData={"items":[{"type":"module","title":"rocksdb","doc":"Erlang Wrapper for RocksDB","ref":"rocksdb.html"},{"type":"function","title":"rocksdb.batch/0","doc":"create a new batch in memory. A batch is a nif resource attached to the current process. Pay attention when you share it with other processes as it may not been released. To force its release you will need to use the close_batch function.","ref":"rocksdb.html#batch/0"},{"type":"function","title":"rocksdb.batch_clear/1","doc":"reset the batch, clear all operations.","ref":"rocksdb.html#batch_clear/1"},{"type":"function","title":"rocksdb.batch_count/1","doc":"return the number of operations in the batch","ref":"rocksdb.html#batch_count/1"},{"type":"function","title":"rocksdb.batch_data_size/1","doc":"Retrieve data size of the batch.","ref":"rocksdb.html#batch_data_size/1"},{"type":"function","title":"rocksdb.batch_delete/2","doc":"batch implementation of delete operation to the batch","ref":"rocksdb.html#batch_delete/2"},{"type":"function","title":"rocksdb.batch_delete/3","doc":"like batch_delete/2 but apply the operation to a column family","ref":"rocksdb.html#batch_delete/3"},{"type":"function","title":"rocksdb.batch_merge/3","doc":"add a merge operation to the batch","ref":"rocksdb.html#batch_merge/3"},{"type":"function","title":"rocksdb.batch_merge/4","doc":"like batch_mege/3 but apply the operation to a column family","ref":"rocksdb.html#batch_merge/4"},{"type":"function","title":"rocksdb.batch_put/3","doc":"add a put operation to the batch","ref":"rocksdb.html#batch_put/3"},{"type":"function","title":"rocksdb.batch_put/4","doc":"like batch_put/3 but apply the operation to a column family","ref":"rocksdb.html#batch_put/4"},{"type":"function","title":"rocksdb.batch_rollback/1","doc":"rollback the operations to the latest checkpoint","ref":"rocksdb.html#batch_rollback/1"},{"type":"function","title":"rocksdb.batch_savepoint/1","doc":"store a checkpoint in the batch to which you can rollback later","ref":"rocksdb.html#batch_savepoint/1"},{"type":"function","title":"rocksdb.batch_single_delete/2","doc":"batch implementation of single_delete operation to the batch","ref":"rocksdb.html#batch_single_delete/2"},{"type":"function","title":"rocksdb.batch_single_delete/3","doc":"like batch_single_delete/2 but apply the operation to a column family","ref":"rocksdb.html#batch_single_delete/3"},{"type":"function","title":"rocksdb.batch_tolist/1","doc":"return all the operation sin the batch as a list of operations","ref":"rocksdb.html#batch_tolist/1"},{"type":"function","title":"rocksdb.cache_info/1","doc":"return informations of a cache as a list of tuples. * {capacity, integer &gt;=0} the maximum configured capacity of the cache. * {strict_capacity, boolean} the flag whether to return error on insertion when cache reaches its full capacity. * {usage, integer &gt;=0} the memory size for the entries residing in the cache. * {pinned_usage, integer &gt;= 0} the memory size for the entries in use by the system","ref":"rocksdb.html#cache_info/1"},{"type":"function","title":"rocksdb.cache_info/2","doc":"return the information associated with Item for cache Cache","ref":"rocksdb.html#cache_info/2"},{"type":"function","title":"rocksdb.checkpoint/2","doc":"take a snapshot of a running RocksDB database in a separate directory http://rocksdb.org/blog/2609/use-checkpoints-for-efficient-snapshots/","ref":"rocksdb.html#checkpoint/2"},{"type":"function","title":"rocksdb.close/1","doc":"Close RocksDB","ref":"rocksdb.html#close/1"},{"type":"function","title":"rocksdb.close_backup_engine/1","doc":"stop and close the backup engine note: experimental for testing only","ref":"rocksdb.html#close_backup_engine/1"},{"type":"function","title":"rocksdb.close_updates_iterator/1","doc":null,"ref":"rocksdb.html#close_updates_iterator/1"},{"type":"function","title":"rocksdb.compact_range/4","doc":"Compact the underlying storage for the key range [*begin,*end]. The actual compaction interval might be superset of [*begin, *end]. In particular, deleted and overwritten versions are discarded, and the data is rearranged to reduce the cost of operations needed to access the data. This operation should typically only be invoked by users who understand the underlying implementation. &quot;begin==undefined&quot; is treated as a key before all keys in the database. &quot;end==undefined&quot; is treated as a key after all keys in the database. Therefore the following call will compact the entire database: rocksdb::compact_range(Options, undefined, undefined); Note that after the entire database is compacted, all data are pushed down to the last level containing any data. If the total data size after compaction is reduced, that level might not be appropriate for hosting all the files. In this case, client could set options.change_level to true, to move the files back to the minimum level capable of holding the data set or a given level (specified by non-negative target_level).","ref":"rocksdb.html#compact_range/4"},{"type":"function","title":"rocksdb.compact_range/5","doc":"Compact the underlying storage for the key range [&quot;BeginKey&quot;, &quot;EndKey&quot;). like compact_range/3 but for a column family","ref":"rocksdb.html#compact_range/5"},{"type":"function","title":"rocksdb.count/1","doc":"Return the approximate number of keys in the default column family. Implemented by calling GetIntProperty with &quot;rocksdb.estimate-num-keys&quot; this function is deprecated and will be removed in next major release.","ref":"rocksdb.html#count/1"},{"type":"function","title":"rocksdb.count/2","doc":"Return the approximate number of keys in the specified column family. this function is deprecated and will be removed in next major release.","ref":"rocksdb.html#count/2"},{"type":"function","title":"rocksdb.create_column_family/3","doc":"Create a new column family","ref":"rocksdb.html#create_column_family/3"},{"type":"function","title":"rocksdb.create_new_backup/2","doc":"Captures the state of the database in the latest backup","ref":"rocksdb.html#create_new_backup/2"},{"type":"function","title":"rocksdb.default_env/0","doc":null,"ref":"rocksdb.html#default_env/0"},{"type":"function","title":"rocksdb.delete/3","doc":"Delete a key/value pair in the default column family","ref":"rocksdb.html#delete/3"},{"type":"function","title":"rocksdb.delete/4","doc":"Delete a key/value pair in the specified column family","ref":"rocksdb.html#delete/4"},{"type":"function","title":"rocksdb.delete_backup/2","doc":"deletes a specific backup","ref":"rocksdb.html#delete_backup/2"},{"type":"function","title":"rocksdb.delete_range/4","doc":"Removes the database entries in the range [&quot;BeginKey&quot;, &quot;EndKey&quot;), i.e., including &quot;BeginKey&quot; and excluding &quot;EndKey&quot;. Returns OK on success, and a non-OK status on error. It is not an error if no keys exist in the range [&quot;BeginKey&quot;, &quot;EndKey&quot;). This feature is currently an experimental performance optimization for deleting very large ranges of contiguous keys. Invoking it many times or on small ranges may severely degrade read performance; in particular, the resulting performance can be worse than calling Delete() for each key in the range. Note also the degraded read performance affects keys outside the deleted ranges, and affects database operations involving scans, like flush and compaction. Consider setting ReadOptions::ignore_range_deletions = true to speed up reads for key(s) that are known to be unaffected by range deletions.","ref":"rocksdb.html#delete_range/4"},{"type":"function","title":"rocksdb.delete_range/5","doc":"Removes the database entries in the range [&quot;BeginKey&quot;, &quot;EndKey&quot;). like delete_range/3 but for a column family","ref":"rocksdb.html#delete_range/5"},{"type":"function","title":"rocksdb.destroy/2","doc":"Destroy the contents of the specified database. Be very careful using this method.","ref":"rocksdb.html#destroy/2"},{"type":"function","title":"rocksdb.destroy_column_family/1","doc":null,"ref":"rocksdb.html#destroy_column_family/1"},{"type":"function","title":"rocksdb.destroy_column_family/2","doc":"Destroy a column family","ref":"rocksdb.html#destroy_column_family/2"},{"type":"function","title":"rocksdb.destroy_env/1","doc":"destroy an environment","ref":"rocksdb.html#destroy_env/1"},{"type":"function","title":"rocksdb.drop_column_family/1","doc":null,"ref":"rocksdb.html#drop_column_family/1"},{"type":"function","title":"rocksdb.drop_column_family/2","doc":"Drop a column family","ref":"rocksdb.html#drop_column_family/2"},{"type":"function","title":"rocksdb.flush/2","doc":"Flush all mem-table data.","ref":"rocksdb.html#flush/2"},{"type":"function","title":"rocksdb.flush/3","doc":"Flush all mem-table data for a column family","ref":"rocksdb.html#flush/3"},{"type":"function","title":"rocksdb.fold/4","doc":"Calls Fun(Elem, AccIn) on successive elements in the default column family starting with AccIn == Acc0. Fun/2 must return a new accumulator which is passed to the next call. The function returns the final value of the accumulator. Acc0 is returned if the default column family is empty. this function is deprecated and will be removed in next major release. You should use the iterator API instead.","ref":"rocksdb.html#fold/4"},{"type":"function","title":"rocksdb.fold/5","doc":"Calls Fun(Elem, AccIn) on successive elements in the specified column family Other specs are same with fold/4 this function is deprecated and will be removed in next major release. You should use the iterator API instead.","ref":"rocksdb.html#fold/5"},{"type":"function","title":"rocksdb.fold_keys/4","doc":"Calls Fun(Elem, AccIn) on successive elements in the default column family starting with AccIn == Acc0. Fun/2 must return a new accumulator which is passed to the next call. The function returns the final value of the accumulator. Acc0 is returned if the default column family is empty. this function is deprecated and will be removed in next major release. You should use the iterator API instead.","ref":"rocksdb.html#fold_keys/4"},{"type":"function","title":"rocksdb.fold_keys/5","doc":"Calls Fun(Elem, AccIn) on successive elements in the specified column family Other specs are same with fold_keys/4 this function is deprecated and will be removed in next major release. You should use the iterator API instead.","ref":"rocksdb.html#fold_keys/5"},{"type":"function","title":"rocksdb.gc_backup_engine/1","doc":"Will delete all the files we don't need anymore It will do the full scan of the files/ directory and delete all the files that are not referenced.","ref":"rocksdb.html#gc_backup_engine/1"},{"type":"function","title":"rocksdb.get/3","doc":"Retrieve a key/value pair in the default column family","ref":"rocksdb.html#get/3"},{"type":"function","title":"rocksdb.get/4","doc":"Retrieve a key/value pair in the specified column family","ref":"rocksdb.html#get/4"},{"type":"function","title":"rocksdb.get_approximate_memtable_stats/3","doc":"The method is similar to GetApproximateSizes, except it returns approximate number of records in memtables.","ref":"rocksdb.html#get_approximate_memtable_stats/3"},{"type":"function","title":"rocksdb.get_approximate_memtable_stats/4","doc":null,"ref":"rocksdb.html#get_approximate_memtable_stats/4"},{"type":"function","title":"rocksdb.get_approximate_sizes/3","doc":"For each i in [0,n-1], store in &quot;Sizes[i]&quot;, the approximate file system space used by keys in &quot;[range[i].start .. range[i].limit)&quot;. Note that the returned sizes measure file system space usage, so if the user data compresses by a factor of ten, the returned sizes will be one-tenth the size of the corresponding user data size. If IncludeFlags defines whether the returned size should include the recently written data in the mem-tables (if the mem-table type supports it), data serialized to disk, or both.","ref":"rocksdb.html#get_approximate_sizes/3"},{"type":"function","title":"rocksdb.get_approximate_sizes/4","doc":null,"ref":"rocksdb.html#get_approximate_sizes/4"},{"type":"function","title":"rocksdb.get_backup_info/1","doc":"Returns info about backups in backup_info","ref":"rocksdb.html#get_backup_info/1"},{"type":"function","title":"rocksdb.get_capacity/1","doc":null,"ref":"rocksdb.html#get_capacity/1"},{"type":"function","title":"rocksdb.get_latest_sequence_number/1","doc":"gThe sequence number of the most recent transaction.","ref":"rocksdb.html#get_latest_sequence_number/1"},{"type":"function","title":"rocksdb.get_pinned_usage/1","doc":null,"ref":"rocksdb.html#get_pinned_usage/1"},{"type":"function","title":"rocksdb.get_property/2","doc":"Return the RocksDB internal status of the default column family specified at Property","ref":"rocksdb.html#get_property/2"},{"type":"function","title":"rocksdb.get_property/3","doc":"Return the RocksDB internal status of the specified column family specified at Property","ref":"rocksdb.html#get_property/3"},{"type":"function","title":"rocksdb.get_snapshot_sequence/1","doc":"returns Snapshot's sequence number","ref":"rocksdb.html#get_snapshot_sequence/1"},{"type":"function","title":"rocksdb.get_usage/1","doc":null,"ref":"rocksdb.html#get_usage/1"},{"type":"function","title":"rocksdb.is_empty/1","doc":"is the database empty","ref":"rocksdb.html#is_empty/1"},{"type":"function","title":"rocksdb.iterator/2","doc":"Return a iterator over the contents of the database. The result of iterator() is initially invalid (caller must call iterator_move function on the iterator before using it).","ref":"rocksdb.html#iterator/2"},{"type":"function","title":"rocksdb.iterator/3","doc":"Return a iterator over the contents of the database. The result of iterator() is initially invalid (caller must call iterator_move function on the iterator before using it).","ref":"rocksdb.html#iterator/3"},{"type":"function","title":"rocksdb.iterator_close/1","doc":"Close a iterator","ref":"rocksdb.html#iterator_close/1"},{"type":"function","title":"rocksdb.iterator_move/2","doc":"Move to the specified place","ref":"rocksdb.html#iterator_move/2"},{"type":"function","title":"rocksdb.iterator_refresh/1","doc":"Refresh iterator","ref":"rocksdb.html#iterator_refresh/1"},{"type":"function","title":"rocksdb.iterators/3","doc":"Return a iterator over the contents of the specified column family.","ref":"rocksdb.html#iterators/3"},{"type":"function","title":"rocksdb.list_column_families/2","doc":"List column families","ref":"rocksdb.html#list_column_families/2"},{"type":"function","title":"rocksdb.mem_env/0","doc":null,"ref":"rocksdb.html#mem_env/0"},{"type":"function","title":"rocksdb.merge/4","doc":"Merge a key/value pair into the default column family","ref":"rocksdb.html#merge/4"},{"type":"function","title":"rocksdb.merge/5","doc":"Merge a key/value pair into the specified column family","ref":"rocksdb.html#merge/5"},{"type":"function","title":"rocksdb.new_cache/2","doc":"// Create a new cache.","ref":"rocksdb.html#new_cache/2"},{"type":"function","title":"rocksdb.new_clock_cache/1","doc":null,"ref":"rocksdb.html#new_clock_cache/1"},{"type":"function","title":"rocksdb.new_env/0","doc":"return a default db environment","ref":"rocksdb.html#new_env/0"},{"type":"function","title":"rocksdb.new_env/1","doc":"return a db environment","ref":"rocksdb.html#new_env/1"},{"type":"function","title":"rocksdb.new_lru_cache/1","doc":null,"ref":"rocksdb.html#new_lru_cache/1"},{"type":"function","title":"rocksdb.new_rate_limiter/2","doc":"create new Limiter","ref":"rocksdb.html#new_rate_limiter/2"},{"type":"function","title":"rocksdb.new_sst_file_manager/1","doc":"create new SstFileManager with the default options: RateBytesPerSec = 0, MaxTrashDbRatio = 0.25, BytesMaxDeleteChunk = 64 * 1024 * 1024.","ref":"rocksdb.html#new_sst_file_manager/1"},{"type":"function","title":"rocksdb.new_sst_file_manager/2","doc":"create new SstFileManager that can be shared among multiple RocksDB instances to track SST file and control there deletion rate. * Env is an environment resource created using rocksdb:new_env/{0,1} . * delete_rate_bytes_per_sec : How many bytes should be deleted per second, If this value is set to 1024 (1 Kb / sec) and we deleted a file of size 4 Kb in 1 second, we will wait for another 3 seconds before we delete other files, Set to 0 to disable deletion rate limiting. * max_trash_db_ratio : If the trash size constitutes for more than this fraction of the total DB size we will start deleting new files passed to DeleteScheduler immediately * bytes_max_delete_chunk : if a file to delete is larger than delete chunk, ftruncate the file by this size each time, rather than dropping the whole file. 0 means to always delete the whole file. If the file has more than one linked names, the file will be deleted as a whole. Either way, delete_rate_bytes_per_sec will be appreciated. NOTE that with this option, files already renamed as a trash may be partial, so users should not directly recover them without checking.","ref":"rocksdb.html#new_sst_file_manager/2"},{"type":"function","title":"rocksdb.new_statistics/0","doc":null,"ref":"rocksdb.html#new_statistics/0"},{"type":"function","title":"rocksdb.new_write_buffer_manager/1","doc":"create a new WriteBufferManager.","ref":"rocksdb.html#new_write_buffer_manager/1"},{"type":"function","title":"rocksdb.new_write_buffer_manager/2","doc":"create a new WriteBufferManager. a WriteBufferManager is for managing memory allocation for one or more MemTables. The memory usage of memtable will report to this object. The same object can be passed into multiple DBs and it will track the sum of size of all the DBs. If the total size of all live memtables of all the DBs exceeds a limit, a flush will be triggered in the next DB to which the next write is issued. If the object is only passed to on DB, the behavior is the same as db_write_buffer_size. When write_buffer_manager is set, the value set will override db_write_buffer_size.","ref":"rocksdb.html#new_write_buffer_manager/2"},{"type":"function","title":"rocksdb.next_binary_update/1","doc":null,"ref":"rocksdb.html#next_binary_update/1"},{"type":"function","title":"rocksdb.next_update/1","doc":null,"ref":"rocksdb.html#next_update/1"},{"type":"function","title":"rocksdb.open/2","doc":"Open RocksDB with the defalut column family","ref":"rocksdb.html#open/2"},{"type":"function","title":"rocksdb.open/3","doc":"Open RocksDB with the specified column families","ref":"rocksdb.html#open/3"},{"type":"function","title":"rocksdb.open_backup_engine/1","doc":"open a new backup engine for creating new backups.","ref":"rocksdb.html#open_backup_engine/1"},{"type":"function","title":"rocksdb.open_optimistic_transaction_db/2","doc":null,"ref":"rocksdb.html#open_optimistic_transaction_db/2"},{"type":"function","title":"rocksdb.open_optimistic_transaction_db/3","doc":null,"ref":"rocksdb.html#open_optimistic_transaction_db/3"},{"type":"function","title":"rocksdb.open_readonly/2","doc":null,"ref":"rocksdb.html#open_readonly/2"},{"type":"function","title":"rocksdb.open_readonly/3","doc":"Open read-only RocksDB with the specified column families","ref":"rocksdb.html#open_readonly/3"},{"type":"function","title":"rocksdb.open_with_cf/3","doc":null,"ref":"rocksdb.html#open_with_cf/3"},{"type":"function","title":"rocksdb.open_with_cf_readonly/3","doc":null,"ref":"rocksdb.html#open_with_cf_readonly/3"},{"type":"function","title":"rocksdb.open_with_ttl/4","doc":"Open RocksDB with TTL support This API should be used to open the db when key-values inserted are meant to be removed from the db in a non-strict TTL amount of time Therefore, this guarantees that key-values inserted will remain in the db for &gt;= TTL amount of time and the db will make efforts to remove the key-values as soon as possible after ttl seconds of their insertion. BEHAVIOUR: TTL is accepted in seconds (int32_t)Timestamp(creation) is suffixed to values in Put internally Expired TTL values deleted in compaction only:( Timestamp+ttl&lt;time_now ) Get/Iterator may return expired entries(compaction not run on them yet) Different TTL may be used during different Opens Example: Open1 at t=0 with TTL=4 and insert k1,k2, close at t=2 Open2 at t=3 with TTL=5. Now k1,k2 should be deleted at t&gt;=5 Readonly=true opens in the usual read-only mode. Compactions will not be triggered(neither manual nor automatic), so no expired entries removed","ref":"rocksdb.html#open_with_ttl/4"},{"type":"function","title":"rocksdb.purge_old_backup/2","doc":"deletes old backups, keeping latest num_backups_to_keep alive","ref":"rocksdb.html#purge_old_backup/2"},{"type":"function","title":"rocksdb.put/4","doc":"Put a key/value pair into the default column family","ref":"rocksdb.html#put/4"},{"type":"function","title":"rocksdb.put/5","doc":"Put a key/value pair into the specified column family","ref":"rocksdb.html#put/5"},{"type":"function","title":"rocksdb.release_batch/1","doc":null,"ref":"rocksdb.html#release_batch/1"},{"type":"function","title":"rocksdb.release_cache/1","doc":"release the cache","ref":"rocksdb.html#release_cache/1"},{"type":"function","title":"rocksdb.release_rate_limiter/1","doc":"release the limiter","ref":"rocksdb.html#release_rate_limiter/1"},{"type":"function","title":"rocksdb.release_snapshot/1","doc":"release a snapshot","ref":"rocksdb.html#release_snapshot/1"},{"type":"function","title":"rocksdb.release_sst_file_manager/1","doc":"release the SstFileManager","ref":"rocksdb.html#release_sst_file_manager/1"},{"type":"function","title":"rocksdb.release_statistics/1","doc":"release the Statistics Handle","ref":"rocksdb.html#release_statistics/1"},{"type":"function","title":"rocksdb.release_transaction/1","doc":"release a transaction","ref":"rocksdb.html#release_transaction/1"},{"type":"function","title":"rocksdb.release_write_buffer_manager/1","doc":null,"ref":"rocksdb.html#release_write_buffer_manager/1"},{"type":"function","title":"rocksdb.repair/2","doc":"Try to repair as much of the contents of the database as possible. Some data may be lost, so be careful when calling this function","ref":"rocksdb.html#repair/2"},{"type":"function","title":"rocksdb.restore_db_from_backup/3","doc":"restore from backup with backup_id","ref":"rocksdb.html#restore_db_from_backup/3"},{"type":"function","title":"rocksdb.restore_db_from_backup/4","doc":"restore from backup with backup_id","ref":"rocksdb.html#restore_db_from_backup/4"},{"type":"function","title":"rocksdb.restore_db_from_latest_backup/2","doc":"restore from the latest backup","ref":"rocksdb.html#restore_db_from_latest_backup/2"},{"type":"function","title":"rocksdb.restore_db_from_latest_backup/3","doc":"restore from the latest backup","ref":"rocksdb.html#restore_db_from_latest_backup/3"},{"type":"function","title":"rocksdb.set_capacity/2","doc":"sets the maximum configured capacity of the cache. When the new capacity is less than the old capacity and the existing usage is greater than new capacity, the implementation will do its best job to purge the released entries from the cache in order to lower the usage","ref":"rocksdb.html#set_capacity/2"},{"type":"function","title":"rocksdb.set_db_background_threads/2","doc":"set background threads of a database","ref":"rocksdb.html#set_db_background_threads/2"},{"type":"function","title":"rocksdb.set_db_background_threads/3","doc":"set database background threads of low and high prioriry threads pool of an environment Flush threads are in the HIGH priority pool, while compaction threads are in the LOW priority pool. To increase the number of threads in each pool call:","ref":"rocksdb.html#set_db_background_threads/3"},{"type":"function","title":"rocksdb.set_env_background_threads/2","doc":"set background threads of an environment","ref":"rocksdb.html#set_env_background_threads/2"},{"type":"function","title":"rocksdb.set_env_background_threads/3","doc":"set background threads of low and high prioriry threads pool of an environment Flush threads are in the HIGH priority pool, while compaction threads are in the LOW priority pool. To increase the number of threads in each pool call:","ref":"rocksdb.html#set_env_background_threads/3"},{"type":"function","title":"rocksdb.set_stats_level/2","doc":null,"ref":"rocksdb.html#set_stats_level/2"},{"type":"function","title":"rocksdb.set_strict_capacity_limit/2","doc":"sets strict_capacity_limit flag of the cache. If the flag is set to true, insert to cache will fail if no enough capacity can be free.","ref":"rocksdb.html#set_strict_capacity_limit/2"},{"type":"function","title":"rocksdb.single_delete/3","doc":"Remove the database entry for &quot;key&quot;. Requires that the key exists and was not overwritten. Returns OK on success, and a non-OK status on error. It is not an error if &quot;key&quot; did not exist in the database. If a key is overwritten (by calling Put() multiple times), then the result of calling SingleDelete() on this key is undefined. SingleDelete() only behaves correctly if there has been only one Put() for this key since the previous call to SingleDelete() for this key. This feature is currently an experimental performance optimization for a very specific workload. It is up to the caller to ensure that SingleDelete is only used for a key that is not deleted using Delete() or written using Merge(). Mixing SingleDelete operations with Deletes can result in undefined behavior. Note: consider setting options {sync, true} .","ref":"rocksdb.html#single_delete/3"},{"type":"function","title":"rocksdb.single_delete/4","doc":"like single_delete/3 but on the specified column family","ref":"rocksdb.html#single_delete/4"},{"type":"function","title":"rocksdb.snapshot/1","doc":"return a database snapshot Snapshots provide consistent read-only views over the entire state of the key-value store","ref":"rocksdb.html#snapshot/1"},{"type":"function","title":"rocksdb.sst_file_manager_flag/3","doc":"set certains flags for the SST file manager * max_allowed_space_usage : Update the maximum allowed space that should be used by RocksDB, if the total size of the SST files exceeds MaxAllowedSpace, writes to RocksDB will fail. Setting MaxAllowedSpace to 0 will disable this feature; maximum allowed pace will be infinite (Default value). * compaction_buffer_size : Set the amount of buffer room each compaction should be able to leave. In other words, at its maximum disk space consumption, the compaction should still leave compaction_buffer_size available on the disk so that other background functions may continue, such as logging and flushing. * delete_rate_bytes_per_sec : Update the delete rate limit in bytes per second. zero means disable delete rate limiting and delete files immediately * max_trash_db_ratio : Update trash/DB size ratio where new files will be deleted immediately (float)","ref":"rocksdb.html#sst_file_manager_flag/3"},{"type":"function","title":"rocksdb.sst_file_manager_info/1","doc":"return informations of a Sst File Manager as a list of tuples. * {total_size, Int&gt;0} : total size of all tracked files * {delete_rate_bytes_per_sec, Int &gt; 0} : delete rate limit in bytes per second * {max_trash_db_ratio, Float&gt;0} : trash/DB size ratio where new files will be deleted immediately * {total_trash_size, Int &gt; 0} : total size of trash files * {is_max_allowed_space_reached, Boolean} true if the total size of SST files exceeded the maximum allowed space usage * {max_allowed_space_reached_including_compactions, Boolean} : true if the total size of SST files as well as estimated size of ongoing compactions exceeds the maximums allowed space usage","ref":"rocksdb.html#sst_file_manager_info/1"},{"type":"function","title":"rocksdb.sst_file_manager_info/2","doc":"return the information associated with Item for an SST File Manager SstFileManager","ref":"rocksdb.html#sst_file_manager_info/2"},{"type":"function","title":"rocksdb.statistics_info/1","doc":null,"ref":"rocksdb.html#statistics_info/1"},{"type":"function","title":"rocksdb.stats/1","doc":"Return the current stats of the default column family Implemented by calling GetProperty with &quot;rocksdb.stats&quot;","ref":"rocksdb.html#stats/1"},{"type":"function","title":"rocksdb.stats/2","doc":"Return the current stats of the specified column family Implemented by calling GetProperty with &quot;rocksdb.stats&quot;","ref":"rocksdb.html#stats/2"},{"type":"function","title":"rocksdb.stop_backup/1","doc":null,"ref":"rocksdb.html#stop_backup/1"},{"type":"function","title":"rocksdb.sync_wal/1","doc":"Sync the wal. Note that Write() followed by SyncWAL() is not exactly the same as Write() with sync=true: in the latter case the changes won't be visible until the sync is done. Currently only works if allow_mmap_writes = false in Options.","ref":"rocksdb.html#sync_wal/1"},{"type":"function","title":"rocksdb.tlog_iterator/2","doc":"create a new iterator to retrive ethe transaction log since a sequce","ref":"rocksdb.html#tlog_iterator/2"},{"type":"function","title":"rocksdb.tlog_iterator_close/1","doc":"close the transaction log","ref":"rocksdb.html#tlog_iterator_close/1"},{"type":"function","title":"rocksdb.tlog_next_binary_update/1","doc":"go to the last update as a binary in the transaction log, can be ussed with the write_binary_update function.","ref":"rocksdb.html#tlog_next_binary_update/1"},{"type":"function","title":"rocksdb.tlog_next_update/1","doc":"like tlog_nex_binary_update/1 but also return the batch as a list of operations","ref":"rocksdb.html#tlog_next_update/1"},{"type":"function","title":"rocksdb.transaction/2","doc":"create a new transaction When opened as a Transaction or Optimistic Transaction db, a user can both read and write to a transaction without committing anything to the disk until they decide to do so.","ref":"rocksdb.html#transaction/2"},{"type":"function","title":"rocksdb.transaction_commit/1","doc":"commit a transaction to disk atomically (?)","ref":"rocksdb.html#transaction_commit/1"},{"type":"function","title":"rocksdb.transaction_delete/2","doc":"transaction implementation of delete operation to the transaction","ref":"rocksdb.html#transaction_delete/2"},{"type":"function","title":"rocksdb.transaction_delete/3","doc":"like transaction_delete/2 but apply the operation to a column family","ref":"rocksdb.html#transaction_delete/3"},{"type":"function","title":"rocksdb.transaction_get/3","doc":"do a get operation on the contents of the transaction","ref":"rocksdb.html#transaction_get/3"},{"type":"function","title":"rocksdb.transaction_get/4","doc":"like transaction_get/3 but apply the operation to a column family","ref":"rocksdb.html#transaction_get/4"},{"type":"function","title":"rocksdb.transaction_iterator/2","doc":"Return a iterator over the contents of the database and uncommited writes and deletes in the current transaction. The result of iterator() is initially invalid (caller must call iterator_move function on the iterator before using it).","ref":"rocksdb.html#transaction_iterator/2"},{"type":"function","title":"rocksdb.transaction_iterator/3","doc":"Return a iterator over the contents of the database and uncommited writes and deletes in the current transaction. The result of iterator() is initially invalid (caller must call iterator_move function on the iterator before using it).","ref":"rocksdb.html#transaction_iterator/3"},{"type":"function","title":"rocksdb.transaction_put/3","doc":"add a put operation to the transaction","ref":"rocksdb.html#transaction_put/3"},{"type":"function","title":"rocksdb.transaction_put/4","doc":"like transaction_put/3 but apply the operation to a column family","ref":"rocksdb.html#transaction_put/4"},{"type":"function","title":"rocksdb.transaction_rollback/1","doc":"rollback a transaction to disk atomically (?)","ref":"rocksdb.html#transaction_rollback/1"},{"type":"function","title":"rocksdb.updates_iterator/2","doc":null,"ref":"rocksdb.html#updates_iterator/2"},{"type":"function","title":"rocksdb.verify_backup/2","doc":"checks that each file exists and that the size of the file matches our expectations. it does not check file checksum.","ref":"rocksdb.html#verify_backup/2"},{"type":"function","title":"rocksdb.write/3","doc":"Apply the specified updates to the database. this function will be removed on the next major release. You should use the batch_* API instead.","ref":"rocksdb.html#write/3"},{"type":"function","title":"rocksdb.write_batch/3","doc":"write the batch to the database","ref":"rocksdb.html#write_batch/3"},{"type":"function","title":"rocksdb.write_binary_update/3","doc":"apply a set of operation coming from a transaction log to another database. Can be useful to use it in slave mode.","ref":"rocksdb.html#write_binary_update/3"},{"type":"function","title":"rocksdb.write_buffer_manager_info/1","doc":"return informations of a Write Buffer Manager as a list of tuples.","ref":"rocksdb.html#write_buffer_manager_info/1"},{"type":"function","title":"rocksdb.write_buffer_manager_info/2","doc":"return the information associated with Item for a Write Buffer Manager.","ref":"rocksdb.html#write_buffer_manager_info/2"},{"type":"type","title":"rocksdb.access_hint/0","doc":null,"ref":"rocksdb.html#t:access_hint/0"},{"type":"opaque","title":"rocksdb.backup_engine/0","doc":null,"ref":"rocksdb.html#t:backup_engine/0"},{"type":"type","title":"rocksdb.backup_info/0","doc":null,"ref":"rocksdb.html#t:backup_info/0"},{"type":"opaque","title":"rocksdb.batch_handle/0","doc":null,"ref":"rocksdb.html#t:batch_handle/0"},{"type":"type","title":"rocksdb.block_based_table_options/0","doc":null,"ref":"rocksdb.html#t:block_based_table_options/0"},{"type":"opaque","title":"rocksdb.cache_handle/0","doc":null,"ref":"rocksdb.html#t:cache_handle/0"},{"type":"type","title":"rocksdb.cache_type/0","doc":null,"ref":"rocksdb.html#t:cache_type/0"},{"type":"type","title":"rocksdb.cf_descriptor/0","doc":null,"ref":"rocksdb.html#t:cf_descriptor/0"},{"type":"opaque","title":"rocksdb.cf_handle/0","doc":null,"ref":"rocksdb.html#t:cf_handle/0"},{"type":"type","title":"rocksdb.cf_options/0","doc":null,"ref":"rocksdb.html#t:cf_options/0"},{"type":"type","title":"rocksdb.column_family/0","doc":null,"ref":"rocksdb.html#t:column_family/0"},{"type":"type","title":"rocksdb.compact_range_options/0","doc":null,"ref":"rocksdb.html#t:compact_range_options/0"},{"type":"type","title":"rocksdb.compaction_pri/0","doc":null,"ref":"rocksdb.html#t:compaction_pri/0"},{"type":"type","title":"rocksdb.compaction_style/0","doc":null,"ref":"rocksdb.html#t:compaction_style/0"},{"type":"type","title":"rocksdb.compression_opts/0","doc":null,"ref":"rocksdb.html#t:compression_opts/0"},{"type":"type","title":"rocksdb.compression_type/0","doc":null,"ref":"rocksdb.html#t:compression_type/0"},{"type":"opaque","title":"rocksdb.db_handle/0","doc":null,"ref":"rocksdb.html#t:db_handle/0"},{"type":"type","title":"rocksdb.db_options/0","doc":null,"ref":"rocksdb.html#t:db_options/0"},{"type":"opaque","title":"rocksdb.env/0","doc":null,"ref":"rocksdb.html#t:env/0"},{"type":"opaque","title":"rocksdb.env_handle/0","doc":null,"ref":"rocksdb.html#t:env_handle/0"},{"type":"type","title":"rocksdb.env_priority/0","doc":null,"ref":"rocksdb.html#t:env_priority/0"},{"type":"type","title":"rocksdb.env_type/0","doc":null,"ref":"rocksdb.html#t:env_type/0"},{"type":"type","title":"rocksdb.flush_options/0","doc":null,"ref":"rocksdb.html#t:flush_options/0"},{"type":"type","title":"rocksdb.fold_fun/0","doc":null,"ref":"rocksdb.html#t:fold_fun/0"},{"type":"type","title":"rocksdb.fold_keys_fun/0","doc":null,"ref":"rocksdb.html#t:fold_keys_fun/0"},{"type":"type","title":"rocksdb.iterator_action/0","doc":null,"ref":"rocksdb.html#t:iterator_action/0"},{"type":"opaque","title":"rocksdb.itr_handle/0","doc":null,"ref":"rocksdb.html#t:itr_handle/0"},{"type":"type","title":"rocksdb.merge_operator/0","doc":null,"ref":"rocksdb.html#t:merge_operator/0"},{"type":"type","title":"rocksdb.options/0","doc":null,"ref":"rocksdb.html#t:options/0"},{"type":"type","title":"rocksdb.prepopulate_blob_cache/0","doc":null,"ref":"rocksdb.html#t:prepopulate_blob_cache/0"},{"type":"type","title":"rocksdb.range/0","doc":null,"ref":"rocksdb.html#t:range/0"},{"type":"opaque","title":"rocksdb.rate_limiter_handle/0","doc":null,"ref":"rocksdb.html#t:rate_limiter_handle/0"},{"type":"type","title":"rocksdb.read_options/0","doc":null,"ref":"rocksdb.html#t:read_options/0"},{"type":"type","title":"rocksdb.read_tier/0","doc":null,"ref":"rocksdb.html#t:read_tier/0"},{"type":"type","title":"rocksdb.size_approximation_flag/0","doc":null,"ref":"rocksdb.html#t:size_approximation_flag/0"},{"type":"opaque","title":"rocksdb.snapshot_handle/0","doc":null,"ref":"rocksdb.html#t:snapshot_handle/0"},{"type":"opaque","title":"rocksdb.sst_file_manager/0","doc":null,"ref":"rocksdb.html#t:sst_file_manager/0"},{"type":"opaque","title":"rocksdb.statistics_handle/0","doc":null,"ref":"rocksdb.html#t:statistics_handle/0"},{"type":"type","title":"rocksdb.stats_level/0","doc":null,"ref":"rocksdb.html#t:stats_level/0"},{"type":"opaque","title":"rocksdb.transaction_handle/0","doc":null,"ref":"rocksdb.html#t:transaction_handle/0"},{"type":"type","title":"rocksdb.wal_recovery_mode/0","doc":null,"ref":"rocksdb.html#t:wal_recovery_mode/0"},{"type":"type","title":"rocksdb.write_actions/0","doc":null,"ref":"rocksdb.html#t:write_actions/0"},{"type":"opaque","title":"rocksdb.write_buffer_manager/0","doc":null,"ref":"rocksdb.html#t:write_buffer_manager/0"},{"type":"type","title":"rocksdb.write_options/0","doc":null,"ref":"rocksdb.html#t:write_options/0"},{"type":"extras","title":"Overview","doc":"# erlang-rocksdb - Erlang wrapper for RocksDB. #\n\n:[![Build Status](https://github.com/EnkiMultimedia/erlang-rocksdb/workflows/build/badge.svg)](https://github.com/EnkiMultimedia/erlang-rocksdb/actions?query=workflow%3Abuild)\n[![Hex pm](http://img.shields.io/hexpm/v/rocksdb.svg?style=flat)](https://hex.pm/packages/rocksdb)\n\nCopyright (c) 2016-2025 Benoît Chesneau\n\nFeedback and pull requests welcome! If a particular feature of RocksDB is important to you, please let me know by opening an issue, and I'll prioritize it.","ref":"readme.html"},{"type":"extras","title":"Features - Overview","doc":"- rocksdb 9.10.0 with snappy 1.12.1, lz4 1.8.3\n- Erlang 22 and sup with dirty-nifs enabled\n- all basics db operations\n- batchs support\n- snapshots support\n- checkpoint support\n- column families support\n- transaction logs\n- backup support\n- erlang merge operator\n- customized build support\n- Tested on macosx, freebsd, solaris and linux","ref":"readme.html#features"},{"type":"extras","title":"Usage - Overview","doc":"See the [Doc](https://hexdocs.pm/rocksdb/) for more explanation.\n\n> Note: since the version **0.26.0**, `cmake>=3.4` is required to install `erlang-rocksdb`.","ref":"readme.html#usage"},{"type":"extras","title":"Customized build ## - Overview","doc":"See the [Customized builds](https://hexdocs.pm/rocksdb/CUSTOMIZED_BUILDS.html) for more information.","ref":"readme.html#customized-build"},{"type":"extras","title":"Support - Overview","doc":"Support, Design and discussions are done via the [Github Tracker](https://github.com/EnkiMultimedia/erlang-rocksdb/issues).","ref":"readme.html#support"},{"type":"extras","title":"License - Overview","doc":"Erlang RocksDB is licensed under the Apache License 2.","ref":"readme.html#license"},{"type":"extras","title":"Getting Started","doc":"The Erlang Rocksdb binding provides access to most of the key/value API of the rocksdb library.","ref":"getting_started.html"},{"type":"extras","title":"Installation - Getting Started","doc":"Download the sources from our [Github repository](https://github.com/EnkiMultimedia/erlang-rocksdb)\n\nTo build the application simply run 'rebar3 compile'. \n\n> Note: since the version **0.26.0**, `cmake>=3.4` is required to install `erlang-rocksdb`.\n\nTo run tests run 'rebar3 eunit'. To generate doc, run 'rebar3 edoc'.\n\nOr add it to your rebar config\n\n\n```erlang\n{deps, [\n    ....\n    {rocksdb, {rocksdb, \"1.9.0\"}}\n]}.\n```\n\nOr your mix config file:\n\n```\n{:rocksdb, \"~> 1.0\"}\n```","ref":"getting_started.html#installation"},{"type":"extras","title":"Basic operations - Getting Started","doc":"","ref":"getting_started.html#basic-operations"},{"type":"extras","title":"Open a database - Getting Started","doc":"```erlang\n\nPath = \"/tmp/erocksdb.fold.test\",\nOptions = [{create_if_missing, true}],\n{ok, DB} = rocksdb:open(Path, Options).\n\n```\n\nThis will create a nif resource. \n\n> Makes sure that the process that opened it will stay open across or the session (or that at least one process own it) to prevent any garbage collection of it which will close the database and kill all the resources related (iterators, column families) ...","ref":"getting_started.html#open-a-database"},{"type":"extras","title":"Closing a database - Getting Started","doc":"When you are done with a database run the following function\n\n```erlang\nok = rocksdb:close(DB).\n```\n\n> the database will be automatically closed if no process own it.","ref":"getting_started.html#closing-a-database"},{"type":"extras","title":"Read and Writes - Getting Started","doc":"The library provides put, delete, and get methods to modify/query the database. For example, the following code moves the value stored under key1 to key2.\n\n```erlang\nrocksdb:put(Db, <<\"my key\">>, <<\"my value\">>),\ncase rocksdb:get(Db, <<\"my key\">>, []) of\n  {ok, Value} => io:format(\"retrieved value %p~n\", [Value]);\n  not_found => io:format(\"value not found~n\", []);\n  Error -> io:format(\"operational problem encountered: %p~n\", [Error])\nend,\nrocksdb:delete(Db, <<\"my key\">>).\n```","ref":"getting_started.html#read-and-writes"},{"type":"extras","title":"Atomic Updates - Getting Started","doc":"Note that if the process dies after the Put of key2 but before the delete of key1, the same value may be left stored under multiple keys. Such problems can be avoided by using the function `rocksdb:write/3` class to atomically apply a set of updates:\n\n```erlang\nBatch = [\n  {put, <<\"key1\">>, <<\"value1\">>},\n  {delete, <<\"keytodelete\">>},\n  ...\n],\nrocksdb:write(DB, Batch, [])\n```\n\nYou can also use the [Batch API](Batch-API) that gives you more control about the atomic transactions.","ref":"getting_started.html#atomic-updates"},{"type":"extras","title":"Synchronous writes - Getting Started","doc":"Using the setting `{sync, true}` in any write operations will makes sure to store synchronously on the filesystem your data.","ref":"getting_started.html#synchronous-writes"},{"type":"extras","title":"Iterate your data - Getting Started","doc":"You can start an iterator using the function `rocksdb:iterator/2` :\n\n```erlang\nItrOptions = [],\n{ok, Itr} = iterator(DB, ItrOptions)\n```\n\nYou close the iterator using the function `rocksdb:iterator_close/1`:\n```erlang\nrocksdb:iterator_close(Itr)\n```\n\nthen you can move to the previous or next data using the function `iterator:move/2` :\n\n* move to the next key: `rocksdb:iterator_move(Itr, next)`\n* move to the previous key: `rocksdb:iterator_move(Itr, prev)`\n* start at the first key: `rocksdb:iterator_move(Itr, first)`\n* start at the last key: `rocksdb:iterator_move(Itr, last)`\n* move to a key: `rocksdb:iterator_move(Itr, Key)` or  `rocksdb:iterator_move(Itr,{seek, Key})`\n* move to the previous key of: `rocksdb:iterator_move(Itr,{seek_for_prev, Key})`\n\n> An iterator doesn't support parallel operations, so make sure to use it accordingly.\n\nPrefix seek can be optimized by putting your database in \"prefix seek\" mode using  the option `prefix_extractor` for your DB or column family is specified. See the [Prefix Seek](prefix-seek.html) API for more information.","ref":"getting_started.html#iterate-your-data"},{"type":"extras","title":"Snapshots - Getting Started","doc":"Snapshots provide consistent read-only views over the entire state of the key-value store.The `{snapshot, Snapshot}` can be need to be set in the read options to indicate that a read should operate on a particular version of the DB state.\n\n\n```erlang\n{ok, Snapshot} = rocksdb:snapshot(Db),\nReadOptions = [{snapshot, Snapshot}],\n{ok, Itr} = rocksdb:iterator(DB, ReadOptions),\n... read using iter to view the state when the snapshot was created ...\nrocksdb:iterator_close(Itr),\nrocksdb:release_snapshot(Snapshot)\n```\n\n> Note that when a snapshot is no longer needed, it should be released using the `rocksdb:release_snapshot/1` function. This allows the implementation to get rid of state that was being maintained just to support reading as of that snapshot.","ref":"getting_started.html#snapshots"},{"type":"extras","title":"Column Families - Getting Started","doc":"[Column Families](column_families.html) provide a way to logically partition the database. Users can provide atomic writes of multiple keys across multiple column families and read a consistent view from them.","ref":"getting_started.html#column-families"},{"type":"extras","title":"Backup and Checkpoint - Getting Started","doc":"[Backup](how_to_backup_rocksdb.html) allows users to create periodic incremental backups in a remote file system (think about HDFS or S3) and recover from any of them.\n\n[Checkpoints](checkpoints.html) provides the ability to take a snapshot of a running RocksDB database in a separate directory. Files are hardlinked, rather than copied, if possible, so it is a relatively lightweight operation.","ref":"getting_started.html#backup-and-checkpoint"},{"type":"extras","title":"Merge Operator - Getting Started","doc":"Starting in version 0.21.0, Erlang Rocksdb supports a [Merge Operator](erlang_merge_operator.html) for Erlang data types. A [Bitset Merge Operator](bitset_merge_operator.html) and a [Counter Merge Operator](counter_merge_operator.html) are also available to change a bit at a position in a string or maintain a simple counter.","ref":"getting_started.html#merge-operator"},{"type":"extras","title":"Transactions - Getting Started","doc":"Erlang RocksDB has preliminary support of multi-operation transactions. See [Transactions](transactions.html)","ref":"getting_started.html#transactions"},{"type":"extras","title":"Batch Api","doc":"The Batch API provides full support of the `WriteBatch`  API from rocksdb and allows you to maintain a batch resource that can  be atomically comitted to the database.","ref":"batch_api.html"},{"type":"extras","title":"basic operations - Batch Api","doc":"```\n{ok, Batch} = rocksdb:batch(),\n\nok = rocksdb:batch_put(Batch, <<\"a\">>, <<\"v1\">>),\nok = rocksdb:batch_put(Batch, <<\"b\">>, <<\"v2\">>),\nok = rocksdb:batch_delete(Batch, <<\"b\">>),\n?assertEqual(3, rocksdb:batch_count(Batch)),\n\n?assertEqual(not_found, rocksdb:get(Db, <<\"a\">>, [])),\n?assertEqual(not_found, rocksdb:get(Db, <<\"b\">>, [])),\n\nok = rocksdb:write_batch(Db, Batch, []),\n\n?assertEqual({ok, <<\"v1\">>}, rocksdb:get(Db, <<\"a\">>, [])),\n?assertEqual(not_found, rocksdb:get(Db, <<\"b\">>, [])),\n\nok = rocksdb:release_batch(Batch),\n```","ref":"batch_api.html#basic-operations"},{"type":"extras","title":"rollback - Batch Api","doc":"```\n{ok, Batch} = rocksdb:batch(),\nok = rocksdb:batch_put(Batch, <<\"a\">>, <<\"v1\">>),\nok = rocksdb:batch_put(Batch, <<\"b\">>, <<\"v2\">>),\nok = rocksdb:batch_savepoint(Batch),\nok = rocksdb:batch_put(Batch, <<\"c\">>, <<\"v3\">>),\n?assertEqual(3, rocksdb:batch_count(Batch)),\n?assertEqual([{put, <<\"a\">>, <<\"v1\">>},\n            {put, <<\"b\">>, <<\"v2\">>},\n            {put, <<\"c\">>, <<\"v3\">>}], rocksdb:batch_tolist(Batch)),\nok = rocksdb:batch_rollback(Batch),\n?assertEqual(2, rocksdb:batch_count(Batch)),\n?assertEqual([{put, <<\"a\">>, <<\"v1\">>},\n            {put, <<\"b\">>, <<\"v2\">>}], rocksdb:batch_tolist(Batch)),\nok = rocksdb:close_batch(Batch)\n```\n\nThis api allows you to rollback the records inside a batch from the last checkpont","ref":"batch_api.html#rollback"},{"type":"extras","title":"Bitset Merge Operator","doc":"The bitset operator allows you to maintain a bitmap. You can set or unset a bit at a oisutuib in a fixed bitmap. \n\nEx:\n\n```erlang\n\n {ok, Db} = rocksdb:open(\"/tmp/rocksdb_merge_db.test\",\n                        [{create_if_missing, true},\n                         {merge_operator, {bitset_merge_operator, 1024}}]),\n\nBitmap = << 0:1024/unsigned >>,\nok = rocksdb:put(Db, <<\"bitmap\">>, Bitmap, []),\nok = rocksdb:merge(Db, <<\"bitmap\">>, <<\"+2\">>, []),\n{ok, << 32, _/binary>> } = rocksdb:get(Db, <<\"bitmap\">>, []),\nok = rocksdb:merge(Db, <<\"bitmap\">>, <<\"-2\">>, []),\n{ok, << 0, _/binary>> } = rocksdb:get(Db, <<\"bitmap\">>, []),\nok = rocksdb:merge(Db, <<\"bitmap\">>, <<\"+11\">>, []),\n{ok, << 0, 16, _/binary>> } = rocksdb:get(Db, <<\"bitmap\">>, []),\nok = rocksdb:merge(Db, <<\"bitmap\">>, <<\"+10\">>, []),\n{ok, << 0, 48, _/binary>> } = rocksdb:get(Db, <<\"bitmap\">>, []),\n\nok = rocksdb:merge(Db, <<\"unsetbitmap\">>, <<\"+2\">>, []),\n{ok, << 32, _/binary>> } = rocksdb:get(Db, <<\"unsetbitmap\">>, []),\nok = rocksdb:merge(Db, <<\"unsetbitmap\">>, <<\"-2\">>, []),\n{ok, << 0, _/binary>> } = rocksdb:get(Db, <<\"unsetbitmap\">>, []),\nok = rocksdb:merge(Db, <<\"unsetbitmap\">>, <<\"+11\">>, []),\n{ok, << 0, 16, _/binary>> } = rocksdb:get(Db, <<\"unsetbitmap\">>, []),\nok = rocksdb:merge(Db, <<\"unsetbitmap\">>, <<\"+10\">>, []),\n{ok, << 0, 48, _/binary>> } = rocksdb:get(Db, <<\"unsetbitmap\">>, []),\n\nok = rocksdb:close(Db),\n```","ref":"bitset_merge_operator.html"},{"type":"extras","title":"Counter Merge Operator","doc":"The counter operator allows you to maintain a counter. You can increase or decrease the counter with an integer value \n\nEx:\n\n```erlang\n\n{ok, Db} = rocksdb:open(\"/tmp/rocksdb_merge_db.test\",\n                        [{create_if_missing, true},\n                         {merge_operator, counter_merge_operator}]),\n\nok = rocksdb:merge(Db, <<\"c\">>, << \"1\" >>, []),\n{ok, << \"1\" >>} = rocksdb:get(Db, <<\"c\">>, []),\n\nok = rocksdb:merge(Db, <<\"c\">>, << \"2\" >>, []),\n{ok, << \"3\" >>} = rocksdb:get(Db, <<\"c\">>, []),\n\nok = rocksdb:merge(Db, <<\"c\">>, <<\"-1\">> , []),\n{ok, <<\"2\">>} = rocksdb:get(Db, <<\"c\">>, []),\n\nok = rocksdb:put(Db, <<\"c\">>, <<\"0\">>, []),\n{ok, <<\"0\">>} = rocksdb:get(Db, <<\"c\">>, []),\n\n\nok = rocksdb:close(Db),\n```","ref":"counter_merge_operator.html"},{"type":"extras","title":"Erlang Merge Operator","doc":"Starting in version 0.21.0, Erlang Rocksdb support a [Merge Operator](Erlang-Merge-Operator) for Erlang data types. \n\nRocksDB offers the possibility of doing appends to existing key values efficiently through the use of a [merge operator](https://github.com/facebook/rocksdb/wiki/Merge-Operator). This operator is a user-provided callback that knows how to merge the old value (\"the message\") and the new value (\"the delta\") into a single value (\"the merged value\").\n\nThe [Erlang Merge Operator](Erlang-Merge-Operator) allows two combine two values of the same Erlang data type in a single value. As long as your data is stored as Erlang binary term (encoded using the `term_to_binary` function), , it should be possible to apply a single predefined merge operator in order to take advantage of the RocksDB merge operation. \n\nFor example appending an item to a list (like `++`):\n\n```erlang\n%% store a list encoded using `term_to_binary`\nok = rocksdb:put(Db, <<\"list\">>, term_to_binary([a, b]), []),\n{ok, Bin0} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b] = binary_to_term(Bin0),\n%% append two items\nok = rocksdb:merge(Db, <<\"list\">>, term_to_binary({list_append, [c, d]}), []),\n{ok, Bin1} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b, c, d] = binary_to_term(Bin1),\n```","ref":"erlang_merge_operator.html"},{"type":"extras","title":"Setup a merge operator - Erlang Merge Operator","doc":"To set the merge operator, add it to the columns options (or the db options if only one column) by setting the `merge_operator` option:\n\n```erlang\n{ok, Db} = rocksdb:open(\"mydb\",\n                        [{create_if_missing, true},\n                         {merge_operator, erlang_merge_operator}]).\n```","ref":"erlang_merge_operator.html#setup-a-merge-operator"},{"type":"extras","title":"Operations: - Erlang Merge Operator","doc":"","ref":"erlang_merge_operator.html#operations"},{"type":"extras","title":"on integer - Erlang Merge Operator","doc":"The Erlang merge operator support the `int_add` operation to add an integer value:\n\n```erlang\n ok = rocksdb:put(Db, <<\"i\">>, term_to_binary(0), []),\n{ok, IBin0} = rocksdb:get(Db, <<\"i\">>, []),\n0 = binary_to_term(IBin0),\n\nok = rocksdb:merge(Db, <<\"i\">>, term_to_binary({int_add, 1}), []),\n{ok, IBin1} = rocksdb:get(Db, <<\"i\">>, []),\n1 = binary_to_term(IBin1),\n```","ref":"erlang_merge_operator.html#on-integer"},{"type":"extras","title":"on lists - Erlang Merge Operator","doc":"The Erlang merge operator support the following operations on lists:\n\n* `list_append` like `++` or `lists:append/2`: Returns a new list List3, which is made from the elements of List1 followed by the elements of List2.\n\n```erlang\nok = rocksdb:put(Db, <<\"list\">>, term_to_binary([a, b]), []),\n{ok, Bin0} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b] = binary_to_term(Bin0),\n\nok = rocksdb:merge(Db, <<\"list\">>, term_to_binary({list_append, [c, d]}), []),\n{ok, Bin1} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b, c, d] = binary_to_term(Bin1),\n```\n\n* `list_substract`: like `lists:substract/2` or `--`, Returns a new list List3 that is a copy of List1, subjected to the following procedure: for each element in List2, its first occurrence in List1 is deleted.\n\n```erlang\nok = rocksdb:put(Db, <<\"list\">>, term_to_binary([a, b, c, d, e, a, b, c]), []),\n{ok, Bin0} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b, c, d, e, a, b, c] = binary_to_term(Bin0),\n\nok = rocksdb:merge(Db, <<\"list\">>, term_to_binary({list_substract, [c, a]}), []),\n{ok, Bin1} = rocksdb:get(Db, <<\"list\">>, []),\n[b, d, e, a, b, c] = binary_to_term(Bin1),\n\n```\n\n* `list_set`: to set an element in the list at a position:\n\n```erlang\nok = rocksdb:put(Db, <<\"list\">>, term_to_binary([a, b, c, d, e]), []),\n{ok, Bin0} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b, c, d, e] = binary_to_term(Bin0),\n\nok = rocksdb:merge(Db, <<\"list\">>, term_to_binary({list_set, 2, 'c1'}), []),\n{ok, Bin1} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b, 'c1', d, e] = binary_to_term(Bin1),\n```\n\n* `list_delete` : to delete an 1 or more elements a at position in the list:\n\n```erlang\nok = rocksdb:put(Db, <<\"list\">>, term_to_binary([a, b, c, d, e, f, g]), []),\n{ok, Bin0} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b, c, d, e, f, g] = binary_to_term(Bin0),\n\nok = rocksdb:merge(Db, <<\"list\">>, term_to_binary({list_delete, 2}), []),\n{ok, Bin1} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b, d, e, f, g] = binary_to_term(Bin1),\n\nok = rocksdb:merge(Db, <<\"list\">>, term_to_binary({list_delete, 2, 4}), []),\n{ok, Bin2} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b, g] = binary_to_term(Bin2),\n```\n\n* `list_insert`: to insert N elements at a position in a list:\n\n```erlang\nok = rocksdb:put(Db, <<\"list\">>, term_to_binary([a, b, c, d, e, f, g]), []),\n{ok, Bin0} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b, c, d, e, f, g] = binary_to_term(Bin0),\n\nok = rocksdb:merge(Db, <<\"list\">>, term_to_binary({list_insert, 2, [h, i]}), []),\n{ok, Bin1} = rocksdb:get(Db, <<\"list\">>, []),\n[a, b, h, i, c, d, e, f, g] = binary_to_term(Bin1),\n```","ref":"erlang_merge_operator.html#on-lists"},{"type":"extras","title":"on binary - Erlang Merge Operator","doc":"The Erlang merge operator support the following operations on binaries:\n\n* `binary_append`: to append a binary:\n\n```erlang\nok = rocksdb:merge(Db, <<\"encbin\">>, term_to_binary({binary_append, <<\"abc\">>}), []),\n{ok, Bin1} = rocksdb:get(Db, <<\"encbin\">>, []),\n<<\"testabc\">> = binary_to_term(Bin1),\n\nok = rocksdb:merge(Db, <<\"encbin\">>, term_to_binary({binary_append, <<\"de\">>}), []),\n{ok, Bin2} = rocksdb:get(Db, <<\"encbin\">>, []),\n<<\"testabcde\">> = binary_to_term(Bin2),\n```\n\n* `binary_replace`: Constructs a new binary by replacing the part in the range with the content of replacement. The range is given in bits:\n\n```erlang\n ok = rocksdb:put(Db, <<\"encbin\">>, term_to_binary(<<\"The quick brown fox jumps over the lazy dog.\">>), []),\n{ok, Bin} = rocksdb:get(Db, <<\"encbin\">>, []),\n<<\"The quick brown fox jumps over the lazy dog.\">> = binary_to_term(Bin),\n\nok = rocksdb:merge(Db, <<\"encbin\">>, term_to_binary({binary_replace, 10, 5, <<\"red\">>}), []),\nok = rocksdb:merge(Db, <<\"encbin\">>, term_to_binary({binary_replace, 0, 3, <<\"A\">>}), []),\n{ok, Bin1} = rocksdb:get(Db, <<\"encbin\">>, []),\n<<\"A quick red fox jumps over the lazy dog.\">> = binary_to_term(Bin1),\n\nok = rocksdb:put(Db, <<\"bitmap\">>, term_to_binary(<<1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1>>), []),\nok = rocksdb:merge(Db, <<\"bitmap\">>, term_to_binary({binary_replace, 2, 1, <<0>>}), []),\n{ok, Bin2} = rocksdb:get(Db, <<\"bitmap\">>, []),\n  <<1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1>> = binary_to_term(Bin2),\n```\n\n* `binary_erase`: Constructs a new binary by deleting the part in the range. The range is given in bits:\n\n```erlang\nok = rocksdb:put(Db, <<\"eraseterm\">>, term_to_binary(<<\"abcdefghij\">>), []),\nok = rocksdb:merge(Db, <<\"eraseterm\">>, term_to_binary({binary_erase, 2, 4}), []),\n{ok, Bin} = rocksdb:get(Db, <<\"eraseterm\">>, []),\n<<\"abghij\">> = binary_to_term(Bin),\n```\n\n* `binary_insert`: Constructs a new binary by inserting a part at a position given in bits:\n\n```erlang\nok = rocksdb:put(Db, <<\"insertterm\">>, term_to_binary(<<\"abcdefghij\">>), []),\nok = rocksdb:merge(Db, <<\"insertterm\">>, term_to_binary({binary_insert, 2, <<\"1234\">>}), []),\n{ok, Bin} = rocksdb:get(Db, <<\"insertterm\">>, []),\n<<\"ab1234cdefghij\">> = binary_to_term(Bin),\n```","ref":"erlang_merge_operator.html#on-binary"},{"type":"extras","title":"Checkpoints","doc":"From the rocksdb documentation:\n\nCheckpoint is a feature in RocksDB which provides the ability to take a snapshot of a running RocksDB database in a separate directory. Checkpoints can be used as a point in time snapshot, which can be opened Read-only to query rows as of the point in time or as a Writeable snapshot by opening it Read-Write. Checkpoints can be used for both full and incremental backups.\n\nThe Checkpoint feature enables RocksDB to create a consistent snapshot of a given RocksDB database in the specified directory. If the snapshot is on the same filesystem as the original database, the SST files will be hard-linked, otherwise SST files will be copied. The manifest and CURRENT files will be copied. In addition, if there are multiple column families, log files will be copied for the period covering the start and end of the checkpoint, in order to provide a consistent snapshot across column families.\n\nA Checkpoint object needs to be created for a database before checkpoints are created. The Erlang API is as follows:\n\n```erlang\nrocksdb:checkpoint(DbHandle::db_handle(), Path::file:filename_all()) -> ok | {error, any()}.\n```\n\nThis function will creates a consistent snapshot of the database in the given directory.\n\nThe directory should not already exist and will be created by this API. The directory will be an absolute path. The checkpoint can be used as a ​read-only copy of the DB or can be opened as a standalone DB. When opened read/write, the SST files continue to be hard links and these links are removed when the files are obsoleted. When the user is done with the snapshot, the user can delete the directory to remove the snapshot.","ref":"checkpoints.html"},{"type":"extras","title":"Column Families","doc":"Each key-value pair in RocksDB is associated with exactly one Column Family. If there is no Column Family specified, key-value pair is associated with Column Family \"default\".\n\nColumn Families provide a way to logically partition the database. Some interesting properties:\n\n* Atomic writes across Column Families are supported. This means you can atomically execute Write({cf1, key1, value1}, {cf2, key2, value2}).\n* Consistent view of the database across Column Families.\n* Ability to configure different Column Families independently.\n* On-the-fly adding new Column Families and dropping them. Both operations are reasonably fast.","ref":"column_families.html"},{"type":"extras","title":"basic key/value operations - Column Families","doc":"```erlang\nColumnFamilies = [{\"default\", []}],\n{ok, Db, [DefaultH]} = rocksdb:open_with_cf(\"test.db\", [{create_if_missing, true}], ColumnFamilies),\nok = rocksdb:put(Db, DefaultH, <<\"a\">>, <<\"a1\">>, []),\n{ok,  <<\"a1\">>} = rocksdb:get(Db, DefaultH, <<\"a\">>, []),\nok = rocksdb:put(Db, DefaultH, <<\"b\">>, <<\"b1\">>, []),\n{ok, <<\"b1\">>} = rocksdb:get(Db, DefaultH, <<\"b\">>, []),\n?assertEqual(2, rocksdb:count(Db,DefaultH)),\n\nok = rocksdb:delete(Db, DefaultH, <<\"b\">>, []),\nnot_found = rocksdb:get(Db, DefaultH, <<\"b\">>, []),\n?assertEqual(1, rocksdb:count(Db, DefaultH)),\n\n{ok, TestH} = rocksdb:create_column_family(Db, \"test\", []),\nrocksdb:put(Db, TestH, <<\"a\">>, <<\"a2\">>, []),\n{ok,  <<\"a1\">>} = rocksdb:get(Db, DefaultH, <<\"a\">>, []),\n{ok,  <<\"a2\">>} = rocksdb:get(Db, TestH, <<\"a\">>, []),\n?assertEqual(1, rocksdb:count(Db, TestH)),\nrocksdb:close(Db)\n```","ref":"column_families.html#basic-key-value-operations"},{"type":"extras","title":"iterator operations - Column Families","doc":"```erlang\n{ok, Ref, [DefaultH]} = rocksdb:open_with_cf(\"ltest\", [{create_if_missing, true}], [{\"default\", []}]),\n{ok, TestH} = rocksdb:create_column_family(Ref, \"test\", []),\ntry\nrocksdb:put(Ref, DefaultH, <<\"a\">>, <<\"x\">>, []),\nrocksdb:put(Ref, DefaultH, <<\"b\">>, <<\"y\">>, []),\nrocksdb:put(Ref, TestH, <<\"a\">>, <<\"x1\">>, []),\nrocksdb:put(Ref, TestH, <<\"b\">>, <<\"y1\">>, []),\n\n{ok, DefaultIt} = rocksdb:iterator(Ref, DefaultH, []),\n{ok, TestIt} = rocksdb:iterator(Ref, TestH, []),\n\n?assertEqual({ok, <<\"a\">>, <<\"x\">>},rocksdb:iterator_move(DefaultIt, <<>>)),\n?assertEqual({ok, <<\"a\">>, <<\"x1\">>},rocksdb:iterator_move(TestIt, <<>>)),\n?assertEqual({ok, <<\"b\">>, <<\"y\">>},rocksdb:iterator_move(DefaultIt, next)),\n?assertEqual({ok, <<\"b\">>, <<\"y1\">>},rocksdb:iterator_move(TestIt, next)),\n?assertEqual({ok, <<\"a\">>, <<\"x\">>},rocksdb:iterator_move(DefaultIt, prev)),\n?assertEqual({ok, <<\"a\">>, <<\"x1\">>},rocksdb:iterator_move(TestIt, prev)),\nok = rocksdb:iterator_close(TestIt),\nok = rocksdb:iterator_close(DefaultIt)\nafter\nrocksdb:close(Ref)\nend.\n```","ref":"column_families.html#iterator-operations"},{"type":"extras","title":"Prefix Seek","doc":"When the option `prefix_extractor` is set  for your DB or column family is specified, RocksDB is in a \"prefix seek\" mode, explained below. Example of how to use it:\n\n```erlang\nOptions = [{create_if_missing, true}, {prefix_extractor, {fixed_prefix_transform, 3}}]),\n\n{ok, Db} = rocksdb:open(\"/tmp/erocksdb\", Options),\n\n...\nItr = rocksdb:iterator(Db, []),\nrocksdb:iterator_move(Itr, {seek, <<\"foobar\">>}), %% seek inside the prefix \"foo\"\nrocksdb:iterator_move(Itr, next), %% Find next key-value pair inside prefix \"foo\"\n```\n\nFor now we support to prefix extractor:\n\n* `{fixed_prefix_transform, N}`: for fixed prefix size, where N is the size of the prefix\n* `{capped_prefix_extractor, N}`: for a prefix with a maximum length of N \n\nSee the [rocksdb documentation](https://github.com/facebook/rocksdb/wiki/Prefix-Seek-API-Changes) for more informations about this feature.","ref":"prefix_seek.html"},{"type":"extras","title":"Transactions","doc":"For now only Erlang Rocksdb has preliminary support of Transactions using an OptimisticTransactionDB.","ref":"transactions.html"},{"type":"extras","title":"OptimisticTransactionDB - Transactions","doc":"Optimistic Transactions provide light-weight optimistic concurrency control for workloads that do not expect high contention/interference between multiple transactions.\n\nOptimistic Transactions do not take any locks when preparing writes. Instead, they rely on doing conflict-detection at commit time to validate that no other writers have modified the keys being written by the current transaction. If there is a conflict with another write (or it cannot be determined), the commit will return an error and no keys will be written.\n\nOptimistic concurrency control is useful for many workloads that need to protect against occasional write conflicts. However, this many not be a good solution for workloads where write-conflicts occur frequently due to many transactions constantly attempting to update the same keys. For these workloads, using a TransactionDB may be a better fit. An OptimisticTransactionDB may be more performant than a TransactionDB for workloads that have many non-transactional writes and few transactions.\n\n```erlang\n{ok, Db, _} = rocksdb:open_optimistic_transaction_db(DbName, Options),\n{ok, Transaction} = rocksdb:transaction(Db, []),\nok = rocksdb:transaction_put(Transaction, <<\"key\">>, <<\"value\">>),\nok = rocksdb:transaction_delete(Transaction, <<\"key2\">>),\nok = rocksdb:transaction_commit(Transaction),\n```","ref":"transactions.html#optimistictransactiondb"},{"type":"extras","title":"Reading from a Transaction - Transactions","doc":"Transactions also support easily reading the state of keys that are currently batched in a given transaction but not yet committed:\n\n```erlang\nok = rocksdb:put(Transaction, <<\"a\">>, <<\"old\">>),\nok = rocksdb:put(Transaction, <<\"b\">>, <<\"old\">>),\n\n...\nok = rocksdb:transaction_put(Transaction, <<\"a\">>, <<\"new\">>\n\n{ok, <<\"new\">>} = rocksdb:transaction_get(Transaction, <<\"a\">>, []),\n{ok, <<\"old\">>} = rocksdb:transaction_get(Transaction, <<\"b\">>, []),\n```","ref":"transactions.html#reading-from-a-transaction"},{"type":"extras","title":"How to backup rocksdb","doc":"","ref":"how_to_backup_rocksdb.html"},{"type":"extras","title":"Backup API - How to backup rocksdb","doc":"It's possible to setup your Erlang application to handle incremental backup directly using the `backup*` functions from the API.","ref":"how_to_backup_rocksdb.html#backup-api"},{"type":"extras","title":"Creating and verifying a backup - How to backup rocksdb","doc":"```erlang\n\nPath = \"/tmp/erocksdb.fold.test\",\nOptions = [{create_if_missing, true],\n{ok, DB} = rocksdb:open(Path, Options).\n\nBackupDir = \"/tmp/rocksdb_backup\",\n\n{ok, Backup} = rocksdb:open_backup_engine(BackupDir),\n\nrocksdb:put(...), %% do your thing\n\nok = rocksdb:create_new_backup(Backup, DB),\n\nrocksdb:put(...), %% make some more changes\nok = rocksdb:create_new_backup(Backup, DB),\n\n// you can get IDs from backup_info if there are more than two\n{ok, BackupInfos} = rocksdb:get_backup_info(Backup),\n  \nok = rocksdb:verify_backup(Backup, 1),\nok = rocksdb:verify_backup(Backup, 2),\n\nrocksdb:close_backup_engine(Backup),\nrocksdb:close(DB).\n\n```\n\nThis simple example will create a couple backups in \"/tmp/rocksdb_backup\". Note that you can create and verify multiple backups using the same engine. **Backups are incremental.**\n\n> more options will be supported in near future.\n\nOnce you have some backups saved, you can issue `rocksdb:get_backup_info/1` call to get a list of all backups together with information on timestamp of the backup and the size (please note that sum of all backups' sizes is bigger than the actual size of the backup directory because some data is shared by multiple backups). Backups are identified by their always-increasing IDs.\n\nWhen `rocksdb:verify_backup/2` is called, it checks the file sizes in the backup directory against the original sizes of the corresponding files in the db directory. However, we do not verify checksums since it would require reading all the data. Note that the only valid use case for `rocksdb:verify_backup/2` is invoking it on a backup engine after that same engine was used for creating backup(s) because it uses state captured during backup time.","ref":"how_to_backup_rocksdb.html#creating-and-verifying-a-backup"},{"type":"extras","title":"Restoring a backup - How to backup rocksdb","doc":"Restoring is easy:\n\n```erlang \n{ok, Backup2} = rocksdb:open_backup_engine(\"/tmp/rocksdb_backup\"),\nok = rocksdb:restore_from_backup(Backup2, 1,  \"/tmp/rocksdb\", \"/tmp/rocksdb\"),\n```\n\nThis code will restore the first backup back to \"/tmp/rocksdb\". The first parameter of `rocksdb:restore_from_backup/4` is the backup ID, second is target DB directory, and third is the target location of log files (in some DBs they are different from DB directory, but usually they are the same. `rocksdb:restore_from_latest_backup/3` will restore the DB from the latest backup, i.e., the one with the highest ID.\n\nChecksum is calculated for any restored file and compared against the one stored during the backup time. If a checksum mismatch is detected, the restore process is aborted and an error is returned.\n\nFor more infos about the backups internals have a look in the [rocksdb documentation](https://github.com/facebook/rocksdb/wiki/How-to-backup-RocksDB%3F#backup-directory-structure)","ref":"how_to_backup_rocksdb.html#restoring-a-backup"},{"type":"extras","title":"Customize erlang-rocksdb builds","doc":"# Customized builds #\n\nSince version 0.26.0 Erlang wrapper for RocksDB support customized build.\n\nThere are manyoptions added to customize build (all are `OFF` by default):\n\n* `WITH_SYSTEM_ROCKSDB=ON` the driver will link with RocksDB shared library provided by host system\n\n* `WITH_SNAPPY=ON` the driver will link with snappy shared library provided by host system\n\n* `WITH_LZ4=ON` the driver will link with lz4 shared library provided by host system\n\n* `WITH_BZ2=ON` the driver will link with bzip2 shared library provided by host system\n\n* `WITH_ZLIB=ON` the driver will link with zlib shared library provided by host system\n\n* `WITH_ZSTD=ON` the driver will link with zstd shared library provided by host system\n\n* `WITH_CCACHE=ON` the driver will use ccache to cache part of the build. you can also set the `CCACHE_DIR` \n\n* `WITH_TBB=ON` to build with [Threading Building Blocks (TBB)](https://software.intel.com/en-us/intel-tbb)\n\n\n> ⚠️ with the 1.0.0 release `erlang-rocksdb` doesn't build statically with `LZ4` and s`SNAPPY`. To reintroduce this behaviour\n> you can build it with the options `WITH_BUNDLE_SNAPPY` and `WITH_BUNDLE_LZ4`.\n\n\nAll options passes via `ERLANG_ROCKSDB_OPTS` environment variable or via `rebar.config.script`. For example, command\n\n```\n $ export ERLANG_ROCKSDB_OPTS=\"-DERLANG_ROCKSDB_USE_SYSTEM_ROCKSDB=ON -DERLANG_ROCKSDB_USE_SYSTEM_SNAPPY=ON -DERLANG_ROCKSDB_USE_SYSTEM_LZ4=ON\"\n $ make\n```\n\ngives following output on macOS\n\n```\n===> Verifying dependencies...\n===> Compiling rocksdb\n-- Using OTP lib: /usr/local/Cellar/erlang/21.1.4/lib/erlang/lib - found\n-- Using erl_interface version: erl_interface-3.10.4\n-- Using erts version: erts-10.1.3\n-- Found LZ4: /usr/local/lib/liblz4.dylib\n-- Found SNAPPY: /usr/local/lib/libsnappy.dylib\n-- Found RocksDB: /usr/local/lib/librocksdb.dylib (found suitable version \"5.17.2\", minimum required is \"5.17.2\")\n-- Configuring done\n-- Generating done\n\n...\n[SKIP BUILD OUTPUT]\n...\n\n```","ref":"customized_builds.html"},{"type":"extras","title":"Build in parallel - Customize erlang-rocksdb builds","doc":"You can  build `erlang-rocksdb` in parallel by passing the following option `ERLANG_ROCKSDB_BUILDOPTS=-j` \nor  `ERLANG_ROCKSDB_BUILDOPTS=-j N` where N is the number of threads you want to use.","ref":"customized_builds.html#build-in-parallel"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"erlang-rockksdb 1.9.0, released on 2025/02/01 - Changelog","doc":"- bump to rocksdb version [9.10.0]((https://github.com/facebook/rocksdb/releases/tag/v9.10.0)\n- bump to snappy 1.2.1\n- fix write_options\n- fix memory leak\n- handle manual_wal_flush option","ref":"changelog.html#erlang-rockksdb-1-9-0-released-on-2025-02-01"},{"type":"extras","title":"erlang-rocksdb 1.8.0, released on 2022/11/04 - Changelog","doc":"- bring compatibility with with Apple Mac M1 and Erlang OTP 25 \n- bump to rocksdb version [7.7.3]((https://github.com/facebook/rocksdb/releases/tag/v7.7.3)\n- add support for BLOB databases\n- add `rocksdb:transaction_rollback/1` function\n- add `rocksdb:release_transaction/1` function\n- fix: bind transactions OPs that require it to IO threads.\n- fix transaction iterator\n- fix transaction leaks: ensure the resource is always closed\n- fix specs\n\n** BREAKING CHANGES **\n\n- rocksdb:transction_commit doesn't delete the transaction\n- `rocksdb_transaction:iterators`: database handle is removed from the functions parameter. Instead only use the\ntransaction resource.","ref":"changelog.html#erlang-rocksdb-1-8-0-released-on-2022-11-04"},{"type":"extras","title":"erlang-rocksdb 1.7.0, released on 2021/11/03 - Changelog","doc":"- bring compatibility with with Apple Mac M1 and Erlang OTP 24\n- bump to rocksdb version [6.25.3]((https://github.com/facebook/rocksdb/releases/tag/v6.25.3)\n- add `rocksdb:open_readonly/3` function to open databases in read only mode (useful for concurrency)\n- add support for read options `read_tier`\n- add support for direct IO  options `use_direct_reads` & `use_direct_io_for_flush_and_compaction`\n- new staistics API, exposing `rocksdb::Statistics` object.\n- fix list merge operaion when empty\n- add `unordered_write` and & `two_write_queues` open options\n- fix `transaction_get`  when Options is unset.\n- fix iterator behaviour","ref":"changelog.html#erlang-rocksdb-1-7-0-released-on-2021-11-03"},{"type":"extras","title":"REAKING CHANGES - Changelog","doc":"- return an invalid iterator if the user try to use next or prev without\nhaving set the initial location of the iterator:\n  - calling next, and prev without having put the iterator at a specific\n  key or location (first, last) will now return the tuple `{error, invalid_iterator}`\n  - fix crash when moving to next key on a new iterator.\n  - fix behavior of Refresh. Refresh is supposed to reset completely the\n  state of the iterator. Fix test accordingly.\n\n- `transction_get/2` has been removed, and is replaced by `transction_get/3` with the third argument to spass the options.\n- `transaction_get/3` to get using a column family is now `transaction_get/4`","ref":"changelog.html#reaking-changes"},{"type":"extras","title":"erlang-rocksdb 1.6.0, released on 2020/10/16 - Changelog","doc":"- bump to rocksdb version [6.13.3](https://github.com/facebook/rocksdb/releases/tag/v6.13.3)\n- improve compression support: add comprssion_opts and bottomost_compression support\n- fix memory leaks: RateLimiter, Snapshots, BitsetMergeOperator, Iterators, WriteBinaryUpdayte\n- fix build for OTP 23","ref":"changelog.html#erlang-rocksdb-1-6-0-released-on-2020-10-16"},{"type":"extras","title":"erlang-rocksdb 1.5.1, released on 2020/02/09 - Changelog","doc":"- fix memory leaks in erocksdb::WriteBinaryUpdate, erokcsdb::CompactRange & erocksdb::Repair\n- fix: use code:lib_dir/1 to find correct ei dir","ref":"changelog.html#erlang-rocksdb-1-5-1-released-on-2020-02-09"},{"type":"extras","title":"erlang-rocksdb 1.5.0, released on 2020/01/21 - Changelog","doc":"- Fix lz4 and snappy lib install dir to work on systems using lib64\n- Add `atomic_flush` db option\n- bump rocksdb to version [6.5.2](https://github.com/facebook/rocksdb/releases/tag/v6.5.2)","ref":"changelog.html#erlang-rocksdb-1-5-0-released-on-2020-01-21"},{"type":"extras","title":"erlang-rocksdb 1.4.0, released on 2019/11/04 - Changelog","doc":"- fix build on OpenBSD\n- bump rocksdb to version [6.4.6](https://github.com/facebook/rocksdb/releases/tag/v6.4.6)","ref":"changelog.html#erlang-rocksdb-1-4-0-released-on-2019-11-04"},{"type":"extras","title":"erlang-rocksdb 1.3.2, released on 2019/09/13 - Changelog","doc":"- fix build using installed rocksdb on the system","ref":"changelog.html#erlang-rocksdb-1-3-2-released-on-2019-09-13"},{"type":"extras","title":"erlang-rocksdb 1.3.1, released on 2019/08/28 - Changelog","doc":"- fix cache_info segfault","ref":"changelog.html#erlang-rocksdb-1-3-1-released-on-2019-08-28"},{"type":"extras","title":"erlang-rocksdb 1.3.0, released on 2019/08/26 - Changelog","doc":"- bump rocksdb to version [6.2.2](https://github.com/facebook/rocksdb/releases/tag/v6.2.2)\n- new: support of the windows platform (build using MSVC)\n- fix: transaction log iterator","ref":"changelog.html#erlang-rocksdb-1-3-0-released-on-2019-08-26"},{"type":"extras","title":"erlang-rocksdb 1.2.0, released on 2019/06/11 - Changelog","doc":"- bump rocksdb to version [6.1.2](https://github.com/facebook/rocksdb/releases/tag/v6.1.2)\n- use C++11 atomics to replace pthreads and GCC specific threading and atomics\n- fix: parralelism build options\n- fix: miscellaneous dialyze and C warnings","ref":"changelog.html#erlang-rocksdb-1-2-0-released-on-2019-06-11"},{"type":"extras","title":"erlang-rocksdb 1.1.1, released on 2019/04/12 - Changelog","doc":"- fix spec\n\nerlang-rocksdb 1.1.0, released on 2019/03/26\n\n- bump rocksdb to version [5.18.3](https://github.com/facebook/rocksdb/releases/tag/v5.18.3)\n- add preliminary support for optimistic transactions\n- make build more parallel when cores are available\n- fix iterate_upper_bound type.","ref":"changelog.html#erlang-rocksdb-1-1-1-released-on-2019-04-12"},{"type":"extras","title":"erlang-rocksdb 1.0.0, released on 2019/01/31 - Changelog","doc":"- first stable version\n- miscellaneous build improvements with [new build options and optimisations](https://gitlab.com/barrel-db/erlang-rocksdb/blob/master/doc/customize_rocksdb_build.md)\n- stable API (refactored in #87, #88)","ref":"changelog.html#erlang-rocksdb-1-0-0-released-on-2019-01-31"},{"type":"extras","title":"erlang-rocksdb 0.26.2, released on 2019/01/24 - Changelog","doc":"- fix `batch_merge/3` to call the right function","ref":"changelog.html#erlang-rocksdb-0-26-2-released-on-2019-01-24"},{"type":"extras","title":"erlang-rocksdb 0.26.1, released on 2018/12/11 - Changelog","doc":"- fix build on freebsd\n- support build with the Thread Building Blocks library (TBB)","ref":"changelog.html#erlang-rocksdb-0-26-1-released-on-2018-12-11"},{"type":"extras","title":"erlang-rocksdb 0.26.0, released on 2018/12/05 - Changelog","doc":"- allows [customized builds](http://gitlab.com/barrel-db/erlang-rocksdb/blob/master/doc/customize_rocksdb_build.md)\n- fix compilations warnings","ref":"changelog.html#erlang-rocksdb-0-26-0-released-on-2018-12-05"},{"type":"extras","title":"BREAKING CHANGES - Changelog","doc":"- build is now using cmake instead of autotools\n- corruption errors return `{error, {corruption, Reaason :: string()}}` inst#ead of `corruption`.","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"erlang-rocksdb 0.25.0, released on 2018/11/21 - Changelog","doc":"- bump to rocksdb 0.17.2\n- bump snappy to 1.1.7\n- bump lz4  to 1.8.3\n- add `rocksdb:open_with_ttl/2`.\n- add `no_slowdown` and `low_pri` write options\n- add `manual_wal_flush`  db option\n- add support for WriteBuffer (#64)\n- add `sst_file_manger()` resource to provide SSTFileManager support and manage disk space. (#74)\n- fix `aproximate_sizes_test` and `approximate_memtable_stats_test`","ref":"changelog.html#erlang-rocksdb-0-25-0-released-on-2018-11-21"},{"type":"extras","title":"BREAKING CHANGES - Changelog","doc":"- handle flush options in rocksdb:flush/{2, 3}\n  With this change `rocksdb:flush/1` has been removed while second parameter\n  of `rocksdb:flush/2` are now `FlushOptions::flush_options()`.\n  Use `rocksdb:flush/3` to flush a column family\n- change signature of `rocksdb:get_approximate_memtable_stats/{2,3}`\n  to `rocksdb:get_approximate_memtable_stats/4` .","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"erlang-rocksdb 0.24.0, released on 2018/11/06 - Changelog","doc":"- add `rocksdb:get_approximate_sizes/{3,4}`: amroximate the size of a range of keys\n- add `rocksdb:get_approximate_memtable_stats/{2,3}` : aproximate the size and the \n  number of keys in a memtable\n- add `rocksdb:compact_range/{4,5}`: Compact the underlying storage for a key","ref":"changelog.html#erlang-rocksdb-0-24-0-released-on-2018-11-06"},{"type":"extras","title":"erlang-rocksdb 0.23.3, released on 2018/10/31 - Changelog","doc":"- fix possible memory leaks when trying to open a bad CF resource.","ref":"changelog.html#erlang-rocksdb-0-23-3-released-on-2018-10-31"},{"type":"extras","title":"erlang-rocksdb 0.23.2, released on 2018/10/30 - Changelog","doc":"- fix memory leaks","ref":"changelog.html#erlang-rocksdb-0-23-2-released-on-2018-10-30"},{"type":"extras","title":"erlang-rocksdb 0.23.1, released on 2018/10/08 - Changelog","doc":"- fix bitset merge operator under load","ref":"changelog.html#erlang-rocksdb-0-23-1-released-on-2018-10-08"},{"type":"extras","title":"erlang-rocksdb 0.23.0, released on 2018/10/05 - Changelog","doc":"- add bytewise and reverse bytewise comparators\n- add iterate_upper_bound, iterate_lower_bound_options and prefix_same_as_start to iterator options\n- improve: prevernt garbage collection in batch\n- fix bitset merge operator, handle exceptions\n- fix counter merge operator, handle exceptions","ref":"changelog.html#erlang-rocksdb-0-23-0-released-on-2018-10-05"},{"type":"extras","title":"erlang-rocksdb 0.22.0, released on 2018/09/25 - Changelog","doc":"- fix NIF memory leak in `erocksdb::Get`\n- add counter_merge_operator","ref":"changelog.html#erlang-rocksdb-0-22-0-released-on-2018-09-25"},{"type":"extras","title":"erlang-rocksdb 0.21.0, released on 2018/09/16 - Changelog","doc":"- bump to rocksdb 5.15.10\n- add: erlang merge operator\n- add: erlang bitset merge operator\n- add: rocksdb:batch_data_size/1\n- add: prefix_transform option","ref":"changelog.html#erlang-rocksdb-0-21-0-released-on-2018-09-16"},{"type":"extras","title":"erlang-rocksdb 0.20.0, released on 2018/08/03 - Changelog","doc":"- bump to rocksdb 5.14.2","ref":"changelog.html#erlang-rocksdb-0-20-0-released-on-2018-08-03"},{"type":"extras","title":"erlang-rocksdb 0.19.0, released on 2018/07/04 - Changelog","doc":"- bump to rocksdb 5.13.4\n- add `rocksdb:set_strict_capacity_limit/2` for cache\n- add `optimize_filters_for_hits` database option\n- add `new_table_reader_for_compaction_inputs` database option\n- add `max_subcompactions` database option","ref":"changelog.html#erlang-rocksdb-0-19-0-released-on-2018-07-04"},{"type":"extras","title":"erlang-rocksdb 0.18.0, released on 2018/05/03 - Changelog","doc":"- bump to rocksdb 5.12.4","ref":"changelog.html#erlang-rocksdb-0-18-0-released-on-2018-05-03"},{"type":"extras","title":"erlang-rocksdb 0.17.0, released on 2018/03/25 - Changelog","doc":"- bump ro rocksdb 5.11.3\n- improve build to make it faster, only use makefiles\n- optimise single operations Get/Put/Delete/DeleteSing: don't call batch\n- optimise write: use batch and do less operations in the the nif: make scheduler happy\n- fix leak in batch\n- breaking change: rename `close_batch/1`  in `relase_batch/1`","ref":"changelog.html#erlang-rocksdb-0-17-0-released-on-2018-03-25"},{"type":"extras","title":"erlang-rocksdb 0.16.0, released on 2018/03/13 - Changelog","doc":"- add single_delete operation (to key/value and batch api)\n- add iterator_refresh function\n- add support for level_compaction_dynamic_level_bytes for column family options\n- add rate_limiter support\n- many optimisations to the source code and build\n- bump to rocksdb 5.10.4","ref":"changelog.html#erlang-rocksdb-0-16-0-released-on-2018-03-13"},{"type":"extras","title":"erlang-rocksdb 0.15.0, released on 2018/02/10 - Changelog","doc":"- add support for lz4 compression\n- add new database option `max_background_jobs`\n- fix: potential memory leak","ref":"changelog.html#erlang-rocksdb-0-15-0-released-on-2018-02-10"},{"type":"extras","title":"erlang-rocksdb 0.14.0, released on 2018/01/31 - Changelog","doc":"- bump to rocksdb 5.7.5\n- bump to snappy 1.1.4","ref":"changelog.html#erlang-rocksdb-0-14-0-released-on-2018-01-31"},{"type":"extras","title":"erlang-rocksdb 0.13.1, released on 2017/09/07 - Changelog","doc":"- fix: remove memory leaks spotted with valgrind","ref":"changelog.html#erlang-rocksdb-0-13-1-released-on-2017-09-07"},{"type":"extras","title":"erlang-rocksdb 0.13.0, released on 2017/09/06 - Changelog","doc":"* add new cache api\n\n\t-  new_lru_cache/1,\n\t-  new_clock_cache/1,\n\t-  get_usage/1,\n\t-  get_pinned_usage/1,\n\t-  set_capacity/2,\n\t-  get_capacity/1\n\t-  release_cache/1\n\n* add new env api\n\n\t- default_env/0,\n\t- mem_env/0,\n\t- set_env_background_threads/{2, 3},\n\t- destroy_env/1\n\n* remove default shared block cache in private env to reduce the vm memory usage.","ref":"changelog.html#erlang-rocksdb-0-13-0-released-on-2017-09-06"},{"type":"extras","title":"erlang-rocksdb 0.12.0, released on 2017/09/05 - Changelog","doc":"- add get_block_cache_usage/1\n- add block_cache_capacity/{1, 0}\n- add new db option {env, Env} where Env can be `default` or `memenv`.\n- add new db option {db_write_buffer_size, INT}\n- fix: cache usahe, correctly reuse the cache among instances\n- fix: options parsing, reuse code where we can and correctly\nhandle db optinos","ref":"changelog.html#erlang-rocksdb-0-12-0-released-on-2017-09-05"},{"type":"extras","title":"BREAKING CHANGE - Changelog","doc":"The following cache functions has been removed:\n\n-  new_lru_cache/1,\n-  new_clock_cache/1,\n-  get_usage/1,\n-  get_pinned_usage/1,\n-  set_capacity/2,\n-  get_capacity/1\n\ninstead use the new block_cache function to change the\nsize of the shared cache. A new api to setup different caches\nwill come in the next version.\n\nThe following functions has been removed:\n\n- default_env/0,\n- mem_env/0,\n- set_background_threads/2, set_background_threads/3,\n- destroy_env/1]).\n\nFor now it's not possible to create a shared environment. also\nthe {in_memory, true} setting has been removed.\n\nTo set a memory environement use the option {env, memenv}.","ref":"changelog.html#breaking-change"},{"type":"extras","title":"erlang-rocksdb 0.11.0, released on 2017/07/29 - Changelog","doc":"- add rocksdb:get_snapshot_sequence/1","ref":"changelog.html#erlang-rocksdb-0-11-0-released-on-2017-07-29"},{"type":"extras","title":"erlang-rocksdb 0.10.0, released on 2017/07/28 - Changelog","doc":"- bump to rocksdb 5.7.2\n- add: rocksdb:delete_range/{4,5}\n- add: support for the backup api\n- add: rocksdb:destroy_column_family/1\n- proper fix to handle an iterator with column family issue","ref":"changelog.html#erlang-rocksdb-0-10-0-released-on-2017-07-28"},{"type":"extras","title":"erlang-rocksdb 0.9.1, released on 2017/07/26 - Changelog","doc":"- fix iterator with column familly issue\n- fix mutex usage igit push --tagsn the db object","ref":"changelog.html#erlang-rocksdb-0-9-1-released-on-2017-07-26"},{"type":"extras","title":"erlang-rocksdb 0.9.0, released on 2017/05/31 - Changelog","doc":"- bump to rocksdb 5.4.5\n- remove `disable_data_sync` db option, optimisations removed in rocksdb\n- remove `timeout_hint_us` db option, was useless since 2 years\n- remove `verify_checksums_in_compaction` db option. it's always done.\n- remove `skip_table_builder_flush` db option\n- remove `allow_os_buffer` db option\n- add `{seek_for_prev, Prev}` db option\n- allows to fold a column familly","ref":"changelog.html#erlang-rocksdb-0-9-0-released-on-2017-05-31"},{"type":"extras","title":"erlang-rocksdb 0.8.2, released on 2017/05/17 - Changelog","doc":"- fix: fix default_env/0 & mem_env/0 spec","ref":"changelog.html#erlang-rocksdb-0-8-2-released-on-2017-05-17"},{"type":"extras","title":"erlang-rocksdb 0.8.1, released on 2017/05/17 - Changelog","doc":"- fix: use an uint64 to set the capacity of LRU or CLOCK caches.","ref":"changelog.html#erlang-rocksdb-0-8-1-released-on-2017-05-17"},{"type":"extras","title":"erlang-rocksdb 0.8.0, released on 2017/05/17 - Changelog","doc":"- replace custom pool by dirty-nif calls\n- allows a cache to be shared between databases (option `block_cache` from the block options)\n- allows an environment to be set and shared across databases (option `env`)\n- add support of batch operations, allows you to incrementatly update it in memory\n- add support for transaction log operations (iteration and replication)","ref":"changelog.html#erlang-rocksdb-0-8-0-released-on-2017-05-17"},{"type":"extras","title":"License","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright [yyyy] [name of copyright owner]\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}